diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/nd6.h head/sys/netinet6/nd6.h
--- clean-head/sys/netinet6/nd6.h	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/nd6.h	2013-06-24 14:21:41.000000000 +0200
@@ -395,7 +395,7 @@ int nd6_is_addr_neighbor(struct sockaddr
 void nd6_option_init(void *, int, union nd_opts *);
 struct nd_opt_hdr *nd6_option(union nd_opts *);
 int nd6_options(union nd_opts *);
-struct	llentry *nd6_lookup(struct in6_addr *, int, struct ifnet *);
+struct        llentry *nd6_lookup(struct in6_addr *, int, struct ifnet *);
 void nd6_setmtu(struct ifnet *);
 void nd6_llinfo_settimer(struct llentry *, long);
 void nd6_llinfo_settimer_locked(struct llentry *, long);
@@ -448,6 +448,8 @@ void rt6_flush(struct in6_addr *, struct
 int nd6_setdefaultiface(int);
 int in6_tmpifadd(const struct in6_ifaddr *, int, int);
 
+void nd6_rtrequest_koh(int, struct rtentry *, struct rt_addrinfo *);
+
 #endif /* _KERNEL */
 
 #endif /* _NETINET6_ND6_H_ */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/nd6_nbr.c head/sys/netinet6/nd6_nbr.c
--- clean-head/sys/netinet6/nd6_nbr.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/nd6_nbr.c	2013-06-24 14:21:41.000000000 +0200
@@ -52,6 +52,9 @@ __FBSDID("$FreeBSD: head/sys/netinet6/nd
 #include <sys/queue.h>
 #include <sys/callout.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #include <net/if.h>
 #include <net/if_types.h>
 #include <net/if_dl.h>
@@ -109,6 +112,7 @@ nd6_ns_input(struct mbuf *m, int off, in
 	struct in6_addr daddr6 = ip6->ip6_dst;
 	struct in6_addr taddr6;
 	struct in6_addr myaddr6;
+	struct rtentry *rt = NULL;
 	char *lladdr = NULL;
 	struct ifaddr *ifa = NULL;
 	int lladdrlen = 0;
@@ -232,7 +236,6 @@ nd6_ns_input(struct mbuf *m, int off, in
 
 	/* (2) check. */
 	if (ifa == NULL) {
-		struct rtentry *rt;
 		struct sockaddr_in6 tsin6;
 		int need_proxy;
 #ifdef RADIX_MPATH
@@ -266,7 +269,6 @@ nd6_ns_input(struct mbuf *m, int off, in
 			 */
 			if (need_proxy)
 				proxydl = *SDL(rt->rt_gateway);
-			RTFREE_LOCKED(rt);
 		}
 		if (need_proxy) {
 			/*
@@ -277,6 +279,19 @@ nd6_ns_input(struct mbuf *m, int off, in
 			if (ifa)
 				proxy = 1;
 		}
+
+#ifdef VPS
+		if (rt && (rt->rt_flags & RTF_PROTO1)) {
+			/* ''Proxy'' ns where we answer with our own lladdr. */
+			DBGCORE("%s: RTF_PROTO1 proxy\n", __func__);
+			ifa = (struct ifaddr *)in6ifa_ifpforlinklocal(ifp,
+				IN6_IFF_NOTREADY|IN6_IFF_ANYCAST);
+			proxy = 0;
+			memset(&proxydl, 0, sizeof (proxydl));
+		}
+#endif
+		if (rt != NULL)
+			RTFREE_LOCKED(rt);
 	}
 	if (ifa == NULL) {
 		/*
@@ -363,6 +378,8 @@ nd6_ns_input(struct mbuf *m, int off, in
  freeit:
 	if (ifa != NULL)
 		ifa_free(ifa);
+	if (rt)
+		RTFREE_LOCKED(rt);
 	m_freem(m);
 	return;
 
@@ -376,6 +393,8 @@ nd6_ns_input(struct mbuf *m, int off, in
 	ICMP6STAT_INC(icp6s_badns);
 	if (ifa != NULL)
 		ifa_free(ifa);
+	if (rt)
+		RTFREE_LOCKED(rt);
 	m_freem(m);
 }
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/nd6_rtr.c head/sys/netinet6/nd6_rtr.c
--- clean-head/sys/netinet6/nd6_rtr.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/nd6_rtr.c	2013-06-24 14:21:41.000000000 +0200
@@ -48,6 +48,7 @@ __FBSDID("$FreeBSD: head/sys/netinet6/nd
 #include <sys/rwlock.h>
 #include <sys/syslog.h>
 #include <sys/queue.h>
+#include <sys/taskqueue.h>
 
 #include <net/if.h>
 #include <net/if_types.h>
@@ -112,6 +113,251 @@ VNET_DEFINE(int, ip6_temp_regen_advance)
 #define RTPREF_INVALID	(-3)	/* internal */
 
 /*
+ * XXX explain PROTO1 route
+ */
+
+struct nd6_rtrequest_koh_sendna_str {
+	struct task sna_task;
+	struct ifnet *sna_ifp;
+	struct rtentry *sna_rt;
+	struct sockaddr_in6 *sna_target;
+#ifdef VIMAGE
+	struct vnet *sna_vnet;
+#endif
+};
+
+void nd6_rtrequest_koh_sendna(void *arg, int pending);
+void
+nd6_rtrequest_koh_sendna(void *arg, int pending)
+{
+	struct nd6_rtrequest_koh_sendna_str *s = (struct nd6_rtrequest_koh_sendna_str *)arg;
+	struct sockaddr_in6 *taddr6;
+	struct in6_addr daddr6;
+	int error;
+
+	CURVNET_SET(s->sna_vnet);
+
+	/* Comes in referenced. */
+	RT_LOCK(s->sna_rt);
+
+	taddr6 = (struct sockaddr_in6 *)rt_key(s->sna_rt);
+	// ff02::1 XXX use the defined values
+	memset(&daddr6, 0, sizeof(daddr6));
+	daddr6.s6_addr8[0] = 0xff;
+	daddr6.s6_addr8[1] = 0x02;
+	daddr6.s6_addr8[15] = 0x01;
+	if ((error = in6_setscope(&daddr6, s->sna_ifp, NULL)) != 0) {
+	        /* XXX: should not happen */
+		printf("%s: in6_setscope failed\n", __func__);
+	        /* XXX cleanup and return */
+	}
+
+	nd6_na_output(s->sna_ifp, &daddr6,
+		&taddr6->sin6_addr,
+		ND_NA_FLAG_OVERRIDE | (V_ip6_forwarding ? ND_NA_FLAG_ROUTER : 0),
+		/* tlladdr */ 1, NULL);
+
+	RTFREE_LOCKED(s->sna_rt);
+	if_rele(s->sna_ifp);
+
+	CURVNET_RESTORE();
+
+	free(s, M_TEMP);
+}
+
+void
+nd6_rtrequest_koh(int req, struct rtentry *rt, struct rt_addrinfo *info)
+{
+	struct sockaddr_in6 *dst6, net6;
+	struct in6_addr llsol;
+	struct in6_multi_mship *imm;
+	struct rtentry *rt2;
+	struct ifnet *srcifp;
+	struct in6_ifaddr *ia;
+	struct nd6_rtrequest_koh_sendna_str *sna;
+	char ip6buf[INET6_ADDRSTRLEN];
+	int error;
+
+	switch (req) {
+	case RTM_ADD:
+		if (rt->rt_flags & RTF_PROTO1 &&
+		    info->rti_addrs & RTA_DST &&
+		    info->rti_addrs & RTA_GATEWAY &&
+		    info->rti_info[RTAX_GATEWAY]->sa_family == AF_LINK) {
+			printf("%s: RTM_ADD; RTF_PROTO1\n", __func__);
+
+			/* info->rti_info[RTAX_DST] ---> sockaddr, the proxied ipv6 address */
+			/* info->rti_info[RTAX_GATEWAY]  ---> sockaddr, the own ll address */
+			/* info->rti_ifp ---> the own _destination_ interface */
+
+			srcifp = NULL;
+			ia = NULL;
+			dst6 = (struct sockaddr_in6 *)info->rti_info[RTAX_DST];
+
+			/* 
+			 * We have to get the interface where the destination address
+			 * would belong to normally.
+			 */
+			/*
+			 * XXX how to get the right route ?!
+			 *     for now use this ugly hack where we assume a prefixlen
+			 *     of 64 for this network on the physical interface.
+			 */
+			/*
+			 * Another (but still ugly and expensive) possibility would be:
+			 *
+			 * Walk through the list of all interfaces and their addresses
+			 * and use the one that has a prefixlen < 128 for and matches
+			 * our destination address.
+			 */
+			memcpy(&net6, dst6, sizeof(net6));
+			net6.sin6_addr.s6_addr32[2] = 0;
+			net6.sin6_addr.s6_addr32[3] = 0;
+			rt2 = rtalloc1((struct sockaddr *)&net6, 0, RTF_RNH_LOCKED);
+			if (rt2) {
+				if_ref(rt2->rt_ifp);
+				srcifp = rt2->rt_ifp;
+				RTFREE_LOCKED(rt2);
+			} else {
+				printf("%s: failed to determine interface for %s\n",
+					__func__, ip6_sprintf(ip6buf, &net6.sin6_addr));
+				goto fail;
+			}
+
+			bzero(&llsol, sizeof(llsol));
+			llsol.s6_addr32[0] = IPV6_ADDR_INT32_MLL;
+			llsol.s6_addr32[1] = 0;
+			llsol.s6_addr32[2] = htonl(1);
+			llsol.s6_addr32[3] = dst6->sin6_addr.s6_addr32[3];
+			llsol.s6_addr8[12] = 0xff;
+			if ((error = in6_setscope(&llsol, srcifp, NULL)) != 0) {
+			        /* XXX: should not happen */
+			        printf("%s: in6_setscope failed\n", __func__);
+			        /* XXX cleanup */
+			        goto fail;
+			}
+			/* XXX causing LOR: rtentry -> in6_multi_mtx */
+			imm = in6_joingroup(srcifp, &llsol, &error, 0 /*delay*/);
+			if (imm == NULL) {
+			        printf("%s: in6_joingroup failed\n", __func__);
+			        /* XXX cleanup */
+			        goto fail;
+			}
+
+			/* XXX not sure if this is alright */
+			ia = in6_ifawithifp(srcifp, &dst6->sin6_addr);
+			if (ia == NULL) {
+				printf("%s: in6_ifawithifp failed\n", __func__);
+				/* XXX cleanup */
+				goto fail;
+			}
+			LIST_INSERT_HEAD(&ia->ia6_memberships, imm, i6mm_chain);
+
+			/* Snd out unsolicited NA immediately */
+			sna = malloc(sizeof(*sna), M_TEMP, M_NOWAIT|M_ZERO);
+			if (sna == NULL) {
+				/* 
+				 * We don't really fail but just omit
+				 * the NA packet, which is only for speeding
+				 * things up, but not necessary.
+				 */
+				goto fail;
+			}
+			sna->sna_ifp = srcifp;
+			if_ref(sna->sna_ifp);
+			sna->sna_rt = rt;
+			RT_ADDREF(sna->sna_rt);
+#ifdef VIMAGE
+			sna->sna_vnet = curvnet;
+#endif
+			TASK_INIT(&sna->sna_task, 0, nd6_rtrequest_koh_sendna, sna);
+			taskqueue_enqueue(taskqueue_thread, &sna->sna_task);
+			
+			fail:
+			if (ia)
+				ifa_free(&ia->ia_ifa);
+			if (srcifp)
+				if_rele(srcifp);
+		}
+		break;
+	case RTM_DELETE:
+		if (rt->rt_flags & RTF_PROTO1 &&
+		    info->rti_addrs & RTA_DST &&
+		    info->rti_addrs & RTA_GATEWAY &&
+		    info->rti_info[RTAX_GATEWAY]->sa_family == AF_LINK) {
+			printf("%s: RTM_DELETE; RTF_PROTO1\n", __func__);
+
+			srcifp = NULL;
+			ia = NULL;
+			dst6 = (struct sockaddr_in6 *)info->rti_info[RTAX_DST];
+
+			/* 
+			 * We have to get the interface where the destination address
+			 * would belong to normally.
+			 *
+			 * XXX - see comments in RTM_ADD section above.
+			 */
+			memcpy(&net6, dst6, sizeof(net6));
+			net6.sin6_addr.s6_addr32[2] = 0;
+			net6.sin6_addr.s6_addr32[3] = 0;
+			rt2 = rtalloc1((struct sockaddr *)&net6, 0, RTF_PROTO1|RTF_RNH_LOCKED);
+			if (rt2) {
+				if_ref(rt2->rt_ifp);
+				srcifp = rt2->rt_ifp;
+				RTFREE_LOCKED(rt2);
+			} else {
+				printf("%s: failed to determine interface for %s\n",
+					__func__, ip6_sprintf(ip6buf, &net6.sin6_addr));
+				goto fail2;
+			}
+
+			bzero(&llsol, sizeof(llsol));
+			llsol.s6_addr32[0] = IPV6_ADDR_INT32_MLL;
+			llsol.s6_addr32[1] = 0;
+			llsol.s6_addr32[2] = htonl(1);
+			llsol.s6_addr32[3] = dst6->sin6_addr.s6_addr32[3];
+			llsol.s6_addr8[12] = 0xff;
+			if ((error = in6_setscope(&llsol, srcifp, NULL)) != 0) {
+			        /* XXX: should not happen */
+			        printf("%s: in6_setscope failed\n", __func__);
+			        /* XXX cleanup */
+			        goto fail2;
+			}
+
+			/* XXX not sure if this is alright */
+			ia = in6_ifawithifp(srcifp, &dst6->sin6_addr);
+			if (ia == NULL) {
+				printf("%s: in6_ifawithifp failed\n", __func__);
+				/* XXX cleanup */
+				goto fail2;
+			}
+			LIST_FOREACH(imm, &ia->ia6_memberships, i6mm_chain)
+				if (IN6_ARE_ADDR_EQUAL(&imm->i6mm_maddr->in6m_addr, &llsol))
+					break;
+
+			if (imm == NULL) {
+				printf("%s: couldn't find previously created multicast address\n",
+					__func__);
+				/* XXX cleanup */
+				goto fail2;
+			}
+
+			LIST_REMOVE(imm, i6mm_chain);
+			in6_leavegroup(imm);
+
+			fail2:
+			if (ia)
+				ifa_free(&ia->ia_ifa);
+			if (srcifp)
+				if_rele(srcifp);
+		}
+		break;
+	default:
+		break;
+	}
+}
+
+/*
  * Receive Router Solicitation Message - just for routers.
  * Router solicitation/advertisement is mostly managed by userland program
  * (rtadvd) so here we have no function like nd6_ra_output().
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netpfil/ipfw/ip_fw_sockopt.c head/sys/netpfil/ipfw/ip_fw_sockopt.c
--- clean-head/sys/netpfil/ipfw/ip_fw_sockopt.c	2013-06-26 09:38:05.000000000 +0200
+++ head/sys/netpfil/ipfw/ip_fw_sockopt.c	2013-06-24 14:21:51.000000000 +0200
@@ -882,7 +882,7 @@ ipfw_getrules(struct ip_fw_chain *chain,
 	int l, i;
 	time_t	boot_seconds;
 
-        boot_seconds = boottime.tv_sec;
+        boot_seconds = V_boottime.tv_sec;
 	for (i = 0; i < chain->n_rules; i++) {
 		rule = chain->map[i];
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/nfs/nfs_diskless.c head/sys/nfs/nfs_diskless.c
--- clean-head/sys/nfs/nfs_diskless.c	2013-06-26 09:35:10.000000000 +0200
+++ head/sys/nfs/nfs_diskless.c	2013-06-24 14:20:29.000000000 +0200
@@ -45,6 +45,8 @@ __FBSDID("$FreeBSD: head/sys/nfs/nfs_dis
 #include <sys/mount.h>
 #include <sys/socket.h>
 
+#include <vps/vps.h>
+
 #include <net/if.h>
 #include <net/if_dl.h>
 #include <net/if_types.h>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/nfs/nfs_lock.c head/sys/nfs/nfs_lock.c
--- clean-head/sys/nfs/nfs_lock.c	2013-06-26 09:35:10.000000000 +0200
+++ head/sys/nfs/nfs_lock.c	2013-06-24 14:20:29.000000000 +0200
@@ -51,6 +51,8 @@ __FBSDID("$FreeBSD: head/sys/nfs/nfs_loc
 #include <sys/unistd.h>
 #include <sys/vnode.h>
 
+#include <vps/vps.h>
+
 #include <net/if.h>
 
 #include <nfs/nfsproto.h>
@@ -284,7 +286,7 @@ nfs_dolock(struct vop_advlock_args *ap)
 		p->p_nlminfo = malloc(sizeof(struct nlminfo),
 		    M_NLMINFO, M_WAITOK | M_ZERO);
 		p->p_nlminfo->pid_start = p->p_stats->p_start;
-		timevaladd(&p->p_nlminfo->pid_start, &boottime);
+		timevaladd(&p->p_nlminfo->pid_start, &G_boottime);
 	}
 	msg.lm_msg_ident.pid_start = p->p_nlminfo->pid_start;
 	msg.lm_msg_ident.msg_seq = ++(p->p_nlminfo->msg_seq);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/nfsclient/nfs_vfsops.c head/sys/nfsclient/nfs_vfsops.c
--- clean-head/sys/nfsclient/nfs_vfsops.c	2013-06-26 09:39:21.000000000 +0200
+++ head/sys/nfsclient/nfs_vfsops.c	2013-06-24 14:20:29.000000000 +0200
@@ -64,6 +64,8 @@ __FBSDID("$FreeBSD: head/sys/nfsclient/n
 #include <vm/vm_extern.h>
 #include <vm/uma.h>
 
+#include <vps/vps.h>
+
 #include <net/if.h>
 #include <net/route.h>
 #include <net/vnet.h>
@@ -540,10 +542,10 @@ nfs_mountroot(struct mount *mp)
 	 * set hostname here and then let the "/etc/rc.xxx" files
 	 * mount the right /var based upon its preset value.
 	 */
-	mtx_lock(&prison0.pr_mtx);
-	strlcpy(prison0.pr_hostname, nd->my_hostnam,
-	    sizeof (prison0.pr_hostname));
-	mtx_unlock(&prison0.pr_mtx);
+	mtx_lock(&V_prison0->pr_mtx);
+	strlcpy(V_prison0->pr_hostname, nd->my_hostnam,
+	    sizeof (V_prison0->pr_hostname));
+	mtx_unlock(&V_prison0->pr_mtx);
 	inittodr(ntohl(nd->root_time));
 	return (0);
 }
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/nfsclient/nfs_vnops.c head/sys/nfsclient/nfs_vnops.c
--- clean-head/sys/nfsclient/nfs_vnops.c	2013-06-26 09:39:21.000000000 +0200
+++ head/sys/nfsclient/nfs_vnops.c	2013-06-24 14:20:29.000000000 +0200
@@ -63,6 +63,8 @@ __FBSDID("$FreeBSD: head/sys/nfsclient/n
 #include <sys/sysctl.h>
 #include <sys/signalvar.h>
 
+#include <vps/vps.h>
+
 #include <vm/vm.h>
 #include <vm/vm_extern.h>
 #include <vm/vm_object.h>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/nfsserver/nfs_serv.c head/sys/nfsserver/nfs_serv.c
--- clean-head/sys/nfsserver/nfs_serv.c	2013-06-26 09:36:12.000000000 +0200
+++ head/sys/nfsserver/nfs_serv.c	2013-06-24 14:20:57.000000000 +0200
@@ -89,6 +89,8 @@ __FBSDID("$FreeBSD: head/sys/nfsserver/n
 #include <sys/buf.h>
 #include <sys/rwlock.h>
 
+#include <vps/vps.h>
+
 #include <vm/vm.h>
 #include <vm/vm_extern.h>
 #include <vm/vm_object.h>
@@ -1153,7 +1155,7 @@ ereply:
 		 * for debugging purposes.
 		 */
 		if (nfsver.tv_sec == 0)
-			nfsver = boottime;
+			nfsver = G_boottime;
 		*tl++ = txdr_unsigned(nfsver.tv_sec);
 		*tl = txdr_unsigned(nfsver.tv_usec);
 	} else if (!error) {
@@ -3419,7 +3421,7 @@ ereply:
 	if (!error) {
 		tl = nfsm_build(u_int32_t *, NFSX_V3WRITEVERF);
 		if (nfsver.tv_sec == 0)
-			nfsver = boottime;
+			nfsver = G_boottime;
 		*tl++ = txdr_unsigned(nfsver.tv_sec);
 		*tl = txdr_unsigned(nfsver.tv_usec);
 	} else {
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/nlm/nlm_advlock.c head/sys/nlm/nlm_advlock.c
--- clean-head/sys/nlm/nlm_advlock.c	2013-06-26 09:35:10.000000000 +0200
+++ head/sys/nlm/nlm_advlock.c	2013-06-24 14:20:29.000000000 +0200
@@ -1220,7 +1220,7 @@ nlm_init_lock(struct flock *fl, int flag
 	oh_len = strlen(oh_space);
 
 	memset(lock, 0, sizeof(*lock));
-	lock->caller_name = prison0.pr_hostname;
+	lock->caller_name = V_prison0->pr_hostname;
 	lock->fh.n_len = fhlen;
 	lock->fh.n_bytes = fh;
 	lock->oh.n_len = oh_len;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/ofed/include/linux/sysfs.h head/sys/ofed/include/linux/sysfs.h
--- clean-head/sys/ofed/include/linux/sysfs.h	2013-06-26 09:38:42.000000000 +0200
+++ head/sys/ofed/include/linux/sysfs.h	2013-06-24 14:20:55.000000000 +0200
@@ -122,7 +122,7 @@ sysfs_create_file(struct kobject *kobj, 
 
 	sysctl_add_oid(NULL, SYSCTL_CHILDREN(kobj->oidp), OID_AUTO,
 	    attr->name, CTLTYPE_STRING|CTLFLAG_RW|CTLFLAG_MPSAFE, kobj,
-	    (uintptr_t)attr, sysctl_handle_attr, "A", "");
+	    (uintptr_t)attr, sysctl_handle_attr, "A", "", VPS_0);
 
 	return (0);
 }
@@ -154,7 +154,7 @@ sysfs_create_group(struct kobject *kobj,
 	for (attr = grp->attrs; *attr != NULL; attr++) {
 		sysctl_add_oid(NULL, SYSCTL_CHILDREN(oidp), OID_AUTO,
 		    (*attr)->name, CTLTYPE_STRING|CTLFLAG_RW|CTLFLAG_MPSAFE,
-		    kobj, (uintptr_t)*attr, sysctl_handle_attr, "A", "");
+		    kobj, (uintptr_t)*attr, sysctl_handle_attr, "A", "", VPS_0);
 	}
 
 	return (0);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/rpc/rpcsec_gss/svc_rpcsec_gss.c head/sys/rpc/rpcsec_gss/svc_rpcsec_gss.c
--- clean-head/sys/rpc/rpcsec_gss/svc_rpcsec_gss.c	2013-06-26 09:39:21.000000000 +0200
+++ head/sys/rpc/rpcsec_gss/svc_rpcsec_gss.c	2013-06-24 14:20:28.000000000 +0200
@@ -76,6 +76,8 @@ __FBSDID("$FreeBSD: head/sys/rpc/rpcsec_
 #include <sys/sx.h>
 #include <sys/ucred.h>
 
+#include <vps/vps.h>
+
 #include <rpc/rpc.h>
 #include <rpc/rpcsec_gss.h>
 
@@ -452,7 +454,7 @@ rpc_gss_svc_getcred(struct svc_req *req,
 	cr->cr_uid = cr->cr_ruid = cr->cr_svuid = uc->uid;
 	cr->cr_rgid = cr->cr_svgid = uc->gid;
 	crsetgroups(cr, uc->gidlen, uc->gidlist);
-	cr->cr_prison = &prison0;
+	cr->cr_prison = V_prison0;
 	prison_hold(cr->cr_prison);
 	*crp = crhold(cr);
 
@@ -512,7 +514,7 @@ svc_rpc_gss_find_client(struct svc_rpc_g
 	rpc_gss_log_debug("in svc_rpc_gss_find_client(%d)", id->ci_id);
 
 	getcredhostid(curthread->td_ucred, &hostid);
-	if (id->ci_hostid != hostid || id->ci_boottime != boottime.tv_sec)
+	if (id->ci_hostid != hostid || id->ci_boottime != G_boottime.tv_sec)
 		return (NULL);
 
 	list = &svc_rpc_gss_client_hash[id->ci_id % CLIENT_HASH_SIZE];
@@ -550,7 +552,7 @@ svc_rpc_gss_create_client(void)
 	sx_init(&client->cl_lock, "GSS-client");
 	getcredhostid(curthread->td_ucred, &hostid);
 	client->cl_id.ci_hostid = hostid;
-	client->cl_id.ci_boottime = boottime.tv_sec;
+	client->cl_id.ci_boottime = G_boottime.tv_sec;
 	client->cl_id.ci_id = svc_rpc_gss_next_clientid++;
 	list = &svc_rpc_gss_client_hash[client->cl_id.ci_id % CLIENT_HASH_SIZE];
 	sx_xlock(&svc_rpc_gss_lock);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/rpc/svc_auth.c head/sys/rpc/svc_auth.c
--- clean-head/sys/rpc/svc_auth.c	2013-06-26 09:39:21.000000000 +0200
+++ head/sys/rpc/svc_auth.c	2013-06-24 14:20:28.000000000 +0200
@@ -49,8 +49,11 @@ __FBSDID("$FreeBSD: head/sys/rpc/svc_aut
 #include <sys/mutex.h>
 #include <sys/systm.h>
 #include <sys/jail.h>
+#include <sys/proc.h>
 #include <sys/ucred.h>
 
+#include <vps/vps.h>
+
 #include <rpc/rpc.h>
 
 static enum auth_stat (*_svcauth_rpcsec_gss)(struct svc_req *,
@@ -180,7 +183,7 @@ svc_getcred(struct svc_req *rqst, struct
 		cr->cr_uid = cr->cr_ruid = cr->cr_svuid = xcr->cr_uid;
 		crsetgroups(cr, xcr->cr_ngroups, xcr->cr_groups);
 		cr->cr_rgid = cr->cr_svgid = cr->cr_groups[0];
-		cr->cr_prison = &prison0;
+		cr->cr_prison = V_prison0;
 		prison_hold(cr->cr_prison);
 		*crp = cr;
 		return (TRUE);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/sys/conf.h head/sys/sys/conf.h
--- clean-head/sys/sys/conf.h	2013-06-26 09:38:52.000000000 +0200
+++ head/sys/sys/conf.h	2013-06-24 14:21:59.000000000 +0200
@@ -276,6 +276,10 @@ int	make_dev_p(int _flags, struct cdev *
 		const char *_fmt, ...) __printflike(8, 9);
 struct cdev *make_dev_alias(struct cdev *_pdev, const char *_fmt, ...)
 		__printflike(2, 3);
+#ifdef VPS
+struct cdev *make_dev_alias_cred(struct cdev *_pdev, struct ucred *_cr,
+		const char *_fmt, ...) __printflike(3, 4);
+#endif
 int	make_dev_alias_p(int _flags, struct cdev **_cdev, struct cdev *_pdev,
 		const char *_fmt, ...) __printflike(4, 5);
 int	make_dev_physpath_alias(int _flags, struct cdev **_cdev,
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/sys/eventhandler.h head/sys/sys/eventhandler.h
--- clean-head/sys/sys/eventhandler.h	2013-06-26 09:38:53.000000000 +0200
+++ head/sys/sys/eventhandler.h	2013-06-24 14:22:00.000000000 +0200
@@ -239,6 +239,14 @@ typedef void (*app_coredump_error_fn)(vo
 
 EVENTHANDLER_DECLARE(app_coredump_start, app_coredump_start_fn);
 EVENTHANDLER_DECLARE(app_coredump_progress, app_coredump_progress_fn);
+
+#ifdef VPS
+struct vps;
+typedef void (*vps_alloc_fn)(void *, struct vps *);
+typedef void (*vps_free_fn)(void *, struct vps *);
+EVENTHANDLER_DECLARE(vps_alloc, vps_alloc_fn);
+EVENTHANDLER_DECLARE(vps_free, vps_free_fn);
+#endif /* VPS */
 EVENTHANDLER_DECLARE(app_coredump_finish, app_coredump_finish_fn);
 EVENTHANDLER_DECLARE(app_coredump_error, app_coredump_error_fn);
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/sys/jail.h head/sys/sys/jail.h
--- clean-head/sys/sys/jail.h	2013-06-26 09:38:53.000000000 +0200
+++ head/sys/sys/jail.h	2013-06-24 14:22:00.000000000 +0200
@@ -318,10 +318,17 @@ prison_unlock(struct prison *pr)
 /*
  * Attributes of the physical system, and the root of the jail tree.
  */
-extern struct	prison prison0;
+#ifdef VPS
+VPS_DECLARE(struct prison *, prison0);
+#define V_prison0       VPSV(prison0)
+#else
+extern struct prison prison0;
+#define V_prison0	(&prison0)
+#endif
 
 TAILQ_HEAD(prisonlist, prison);
-extern struct	prisonlist allprison;
+VPS_DECLARE(struct prisonlist, allprison);
+#define V_allprison VPSV(allprison)
 extern struct	sx allprison_lock;
 
 /*
@@ -330,20 +337,20 @@ extern struct	sx allprison_lock;
 SYSCTL_DECL(_security_jail_param);
 
 #define	SYSCTL_JAIL_PARAM(module, param, type, fmt, descr)		\
-    SYSCTL_PROC(_security_jail_param ## module, OID_AUTO, param,	\
-	(type) | CTLFLAG_MPSAFE, NULL, 0, sysctl_jail_param, fmt, descr)
+    _SYSCTL_PROC(_security_jail_param ## module, OID_AUTO, param,	\
+	(type) | CTLFLAG_MPSAFE, NULL, 0, sysctl_jail_param, fmt, descr, VPS_PUBLIC)
 #define	SYSCTL_JAIL_PARAM_STRING(module, param, access, len, descr)	\
-    SYSCTL_PROC(_security_jail_param ## module, OID_AUTO, param,	\
+    _SYSCTL_PROC(_security_jail_param ## module, OID_AUTO, param,	\
 	CTLTYPE_STRING | CTLFLAG_MPSAFE | (access), NULL, len,		\
-	sysctl_jail_param, "A", descr)
+	sysctl_jail_param, "A", descr, VPS_PUBLIC)
 #define	SYSCTL_JAIL_PARAM_STRUCT(module, param, access, len, fmt, descr)\
-    SYSCTL_PROC(_security_jail_param ## module, OID_AUTO, param,	\
+    _SYSCTL_PROC(_security_jail_param ## module, OID_AUTO, param,	\
 	CTLTYPE_STRUCT | CTLFLAG_MPSAFE | (access), NULL, len,		\
-	sysctl_jail_param, fmt, descr)
+	sysctl_jail_param, fmt, descr, VPS_PUBLIC)
 #define	SYSCTL_JAIL_PARAM_NODE(module, descr)				\
-    SYSCTL_NODE(_security_jail_param, OID_AUTO, module, 0, 0, descr)
-#define	SYSCTL_JAIL_PARAM_SUBNODE(parent, module, descr)		\
-    SYSCTL_NODE(_security_jail_param_##parent, OID_AUTO, module, 0, 0, descr)
+    _SYSCTL_NODE(_security_jail_param, OID_AUTO, module, 0, 0, descr, VPS_PUBLIC)
+#define       SYSCTL_JAIL_PARAM_SUBNODE(parent, module, descr)                \
+    _SYSCTL_NODE(_security_jail_param_##parent, OID_AUTO, module, 0, 0, descr, VPS_PUBLIC)
 #define	SYSCTL_JAIL_PARAM_SYS_NODE(module, access, descr)		\
     SYSCTL_JAIL_PARAM_NODE(module, descr);				\
     SYSCTL_JAIL_PARAM(_##module, , CTLTYPE_INT | (access), "E,jailsys",	\
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/sys/kernel.h head/sys/sys/kernel.h
--- clean-head/sys/sys/kernel.h	2013-06-26 09:38:53.000000000 +0200
+++ head/sys/sys/kernel.h	2013-06-24 14:22:00.000000000 +0200
@@ -110,6 +110,7 @@ enum sysinit_sub_id {
 	SI_SUB_MAC_POLICY	= 0x21C0000,	/* TrustedBSD MAC policies */
 	SI_SUB_MAC_LATE		= 0x21D0000,	/* TrustedBSD MAC subsystem */
 	SI_SUB_VNET		= 0x21E0000,	/* vnet 0 */
+	SI_SUB_VPS		= 0x21E8000,	/* vps setup */
 	SI_SUB_INTRINSIC	= 0x2200000,	/* proc 0*/
 	SI_SUB_VM_CONF		= 0x2300000,	/* config VM, set limits*/
 	SI_SUB_DDB_SERVICES	= 0x2380000,	/* capture, scripting, etc. */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/sys/mount.h head/sys/sys/mount.h
--- clean-head/sys/sys/mount.h	2013-06-26 09:38:53.000000000 +0200
+++ head/sys/sys/mount.h	2013-06-24 14:22:00.000000000 +0200
@@ -185,6 +185,9 @@ struct mount {
 	int		mnt_secondary_writes;   /* (i) # of secondary writes */
 	int		mnt_secondary_accwrites;/* (i) secondary wr. starts */
 	struct thread	*mnt_susp_owner;	/* (i) thread owning suspension */
+#ifdef VPS
+	struct vps	*mnt_vps;		/* VPS instance reference */
+#endif
 #define	mnt_endzero	mnt_gjprovider
 	char		*mnt_gjprovider;	/* gjournal provider name */
 	struct lock	mnt_explock;		/* vfs_export walkers lock */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/sys/msg.h head/sys/sys/msg.h
--- clean-head/sys/sys/msg.h	2013-06-26 09:38:52.000000000 +0200
+++ head/sys/sys/msg.h	2013-06-24 14:22:00.000000000 +0200
@@ -27,6 +27,10 @@
 #include <sys/_types.h>
 #include <sys/ipc.h>
 
+#if defined(_KERNEL) && defined(VPS)
+#include <vps/vps.h>
+#endif
+
 /*
  * The MSG_NOERROR identifier value, the msqid_ds struct and the msg struct
  * are as defined by the SV API Intel 386 Processor Supplement.
@@ -145,7 +149,12 @@ struct msginfo {
 		msgssz,		/* size of a message segment (see notes above) */
 		msgseg;		/* number of message segments */
 };
+#ifndef VPS
 extern struct msginfo	msginfo;
+#else
+VPS_DECLARE(struct msginfo, msginfo);
+#define V_msginfo VPSV(msginfo)
+#endif
 
 /*
  * Kernel wrapper for the user-level structure.
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/sys/msgbuf.h head/sys/sys/msgbuf.h
--- clean-head/sys/sys/msgbuf.h	2013-06-26 09:38:53.000000000 +0200
+++ head/sys/sys/msgbuf.h	2013-06-24 14:22:00.000000000 +0200
@@ -78,7 +78,11 @@ int	msgbuf_peekbytes(struct msgbuf *mbp,
 void	msgbuf_reinit(struct msgbuf *mbp, void *ptr, int size);
 
 #ifndef MSGBUF_SIZE
+#if defined(VPS) && defined(DIAGNOSTIC)
+#define	MSGBUF_SIZE	(64 * 32768 * 3)
+#else
 #define	MSGBUF_SIZE	(32768 * 3)
+#endif /* VPS && DIAGNOSTIC */
 #endif
 #endif /* KERNEL */
 
